<?php

class CustomSoapServer extends SoapServer 
{
    public function __construct($wsdl = null, array $options = null)
    {
        parent::__construct($wsdl, $options);

        // Response of handle will always be returned
        $this->setReturnResponse(true); 
    }

    public function handle($request = null)
    {
        $response = parent::handle($request);
        echo str_replace(array('<return>', '</return>'), array('<ns1:return>', '</ns1:return>'), $response);
        return;
    }
}

?>