<?php

defined( '_LIMAEXEC' ) or die( 'Restricted access' );

// server
class MySoapServer
{

	protected $_instance = array();
	private $authmodule = true;

	function __construct()
	{
		if(SYSLOG_ENABLE == 1) openlog("limalog", LOG_PID | LOG_PERROR, LOG_LOCAL0);
	}


	public function AddDF($request)
	{
	
	        /* get our DB */
                $db = $this->getContainer('db');
                $success = false;

		$query = "SELECT COUNT(*) as cnt FROM df_location WHERE dfid=".$request->dfid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$cnt = $row['cnt'];
		$cnt+=0;
		
		if($cnt == 0 )
                {
                        $query = "INSERT INTO df_location (`dfid`, `name`, `protocol`, `ip`, `port`, `user`, `password`) values ('?','?','?','?','?','?','?');";
                        $query  = $db->makeQuery($query, $request->dfid, $request->name, $request->protocol, $request->ip, $request->port, $request->user, $request->password );
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query);                        
                        
                        $response = array('success' => $success); 	
        		return $response;                                             
                }
                else {
                        $response = array(
                                'errorcode' => 106,
                                'errormessage' => "DF already exist" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>106</errorcode><errormessage>DF already exist</errormessage></fault>';
			$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","DF '".$request->dfid."' already exists", null, $var);         		 
                
                }
				

	}
  
	public function DeleteDF($dfid)
	{
	        
	        /* get our DB */
                $db = $this->getContainer('db');

                $query = "SELECT COUNT(*) as cnt FROM li_records WHERE df2id=".$dfid." OR df3id=".$dfid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$dfcount = $row['cnt'];
		$dfcount+=0;
		
		if($dfcount == 1 || $dfcount == 0) 
		{						
        	        $query = "SELECT COUNT(*) as cnt FROM df_location WHERE dfid=".$dfid;				
        		$rows = $db->loadObjectArray($query);
        		$row = $rows[0];		
	        	$cnt = $row['cnt'];
        		$cnt+=0;
	        	$success = false;
		
        		if($cnt == 1 )
                        {
                                $query = "delete FROM df_location WHERE dfid=".$dfid;
                                $db->executeQuery($query);
                                $success = true;                                                	
                		$response = array('success' => $success);                     
        	        	return $response;                                             	
                        }
                        else {                
                                $response = array(
                                        'errorcode' => 107,
                                        'errormessage' => "DF is not existing and cannot be deleted" 
                		); 
        		
                		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>107</errorcode><errormessage>DF is not existing and cannot be deleted</errormessage></fault>';
		        	$var = new SoapVar ($body_xml, XSD_ANYXML);

                		throw new SoapFault("Server","DF '".$request->dfid."' is not existing and cannot be deleted", null, $var);         		 
                        }                                
                }
                else 
                {
                
                        $response = array(
                                'errorcode' => 107,
                                'errormessage' => "DF in use and cannot be deleted" 
                        ); 
        		
                	$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>107</errorcode><errormessage>DF is use and cannot be deleted</errormessage></fault>';
		        $var = new SoapVar ($body_xml, XSD_ANYXML);

                	throw new SoapFault("Server","DF '".$request->dfid."' is use and cannot be deleted", null, $var);                       
                }                
	}
  
	public function ModifyDF($request)
	{
	
	        /* get our DB */
                $db = $this->getContainer('db');
                $success = false;

		$query = "SELECT COUNT(*) as cnt FROM df_location WHERE dfid=".$request->dfid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$cnt = $row['cnt'];
		$cnt+=0;
		
		if($cnt == 1 )
                {
                        $query = "delete FROM df_location WHERE dfid=".$request->dfid;
                        $db->executeQuery($query);
                        $query = "INSERT INTO df_location (`dfid`, `name`, `protocol`, `ip`, `port`, `user`, `password`) values ('?','?','?','?','?','?','?');";
                        $query  = $db->makeQuery($query, $request->dfid, $request->name, $request->protocol, $request->ip, $request->port, $request->user, $request->password );
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query);                        
                        $response = array('success' => $success);         	
	        	return $response;                                             
                }
                else {                
                        $response = array(
                                'errorcode' => 107,
                                'errormessage' => "DF is not existing and cannot be modified" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>107</errorcode><errormessage>DF is not existing and cannot be modified</errormessage></fault>';
			$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","DF '".$request->dfid."' is not existing and cannot be modified", null, $var);         		 
                }                
	
	}
  
	public function ListDFs($body)
	{
  
	        /* get our DB */
                $db = $this->getContainer('db');
	        $query = "SELECT * FROM df_location";
		$rows = $db->loadObjectArray($query);
		return $rows;                                             
	}
	
	public function RetrieveDF($dfid)
	{
  
	        /* get our DB */
                $db = $this->getContainer('db');
	        $query = "SELECT * FROM df_location where dfid = ".$dfid;
		$rows = $db->loadObjectArray($query);
		if(count($rows)){
        		return $rows[0];                                             
                }
                else {
                
                        $response = array(
                                'errorcode' => 107,
                                'errormessage' => "DF is not existing and cannot be retrieved" 
        		); 


        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>107</errorcode><errormessage>DF is not existing and cannot be retrieved</errormessage></fault>';
			$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","DF '".$dfid."' is not existing and cannot be retrieved", null, $var);         		 
                }
                
		return;
	}


  
	public function ListInterceptions($body)
	{
  
	        /* get our DB */
                $db = $this->getContainer('db');
	        $query = "SELECT * FROM li_records";
		$rows = $db->loadObjectArray($query);
		return $rows;                                             
	}
	
	public function RetrieveInterception($liid)
	{
  
                syslog(LOG_WARNING, "QI: ".$liid); 
                                 
	        /* get our DB */
                $db = $this->getContainer('db');
	        $query = "SELECT * FROM li_records WHERE liid=".$liid;
		$rows = $db->loadObjectArray($query);
		if(count($rows)) {

        		return $rows[0];                                             
                }
                else {
                
                        $response = array(
                                'errorcode' => 100,
                                'errormessage' => "Target is not active and cannot be retrieved" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>100</errorcode><errormessage>Target is not active and cannot be retrieved</errormessage></fault>';
			$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","Target '".$liid."' is not active and cannot be retrieved", null, $var);         		 
                }        
                return;        		
	}
  
	public function AddInterception($request)
	{
		//$body = stdclass"  
		/* stdClass Object
		(
		        [liid] =&gt; 12345
		        [liCorrelation] =&gt; 54321
		        [targetType] =&gt; EMAIL
		        [targetNumber] =&gt; sorry@hamma.net
		        [df2id] =&gt; 222
		        [df3id] =&gt; 333
		)
		*/
		
		/* get our DB */
                $db = $this->getContainer('db');
                $success = false;

		$query = "SELECT COUNT(*) as cnt FROM li_records WHERE liid=".$request->liid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$cnt = $row['cnt'];
		$cnt+=0;
		
		if($cnt == 0 )
		{
                        
                        $request->df2id+=0;
                        $request->df3id+=0;
                        
                        $liobj = new stdclass();
                        $liobj->gid = 10;
                        $liobj->reseller_id = 0;
                        $liobj->aid = $request->liid;                                                   
                        $liobj->LIID = $request->liid;
                        $liobj->uuid = $this->gen_uuid();
                        $liobj->number = $request->liCorrelation;
                        $liobj->sip_username = $request->targetNumber;
                        $liobj->sip_domain = "";
                        $liobj->search_callee = "";
                        $liobj->search_caller = $request->targetNumber;
                        $liobj->search_ip = "";
                        $liobj->cc_required = 0;
                        $liobj->delivery_host = "";
                        $liobj->delivery_port = "";
                        $liobj->delivery_user = "";
                        $liobj->delivery_pass = "";
                        $liobj->cc_delivery_host = "";
                        $liobj->cc_delivery_post = "";
                        $liobj->modify_timestamp = "";
                        $liobj->create_timestamp = "";
                        $liobj->start_time = time() - 100;
                        /* STOP TIME */
                        $liobj->stop_time = time() + (365 * 86400);
                        $liobj->description = "Desciption";
                                               
                        if($request->df2id > 0)
                        {                                                
                                               
                	        $query = "SELECT * FROM df_location WHERE dfid = '?' LIMIT 1";
                	        $query  = $db->makeQuery($query, $request->df2id);        	                                
        	                $dflocs = $db->loadObjectArray($query);
        	                if(count($dflocs) > 0) 
        	                {
                	                foreach($dflocs as $df) {
                                                $liobj->cc_required = 1;
                        	                $liobj->delivery_host = $df['ip'];
                	                        $liobj->delivery_port = $df['port'];
                        	                $liobj->delivery_user = $df['user'];
                	                        $liobj->delivery_pass = $df['password'];        	                                                                                        	        	        	        	
                	        	} 
                                }
                                else {                
                                        $response = array(
                                                'errorcode' => 108,
                                                'errormessage' => "DF does not exist and cannot be used for delivery" 
                        		); 

                                        $body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>108</errorcode><errormessage>DF does not exist and cannot be used for delivery</errormessage></fault>';
                			$var = new SoapVar ($body_xml, XSD_ANYXML);

        	                	throw new SoapFault("Server","DF '".$request->df2id."' does not exist and cannot be used for delivery", null, $var);         		 
                                }        									
                        }                                
	        	
	        	if($request->df3id > 0)
	        	{
        	        	$query = "SELECT * FROM df_location WHERE dfid = '?' LIMIT 1";
                	        $query  = $db->makeQuery($query, $request->df3id);        	                                
        	                $dflocs = $db->loadObjectArray($query);
        	                if(count($dflocs) > 0) 
        	                {
                	                foreach($dflocs as $df) {
                                                $liobj->cc_required = 1;
                        	                $liobj->cc_delivery_host = $df['ip'];
        	                                $liobj->cc_delivery_post = $df['port'];
                                        } 
                                }
                                else {
                
                                        $response = array(
                                                'errorcode' => 108,
                                                'errormessage' => "DF does not exist and cannot be used for delivery" 
                        		); 
                        		
                        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>108</errorcode><errormessage>DF does not exist and cannot be used for delivery</errormessage></fault>';
                			$var = new SoapVar ($body_xml, XSD_ANYXML);

        	                	throw new SoapFault("Server","DF '".$request->df3id."' does not exist and cannot be used for delivery", null, $var);         		 
                                }        									
                        }                        
	        
                        $query = "INSERT INTO li_records (liid, liCorrelation, targetType, targetNumber, df2id, df3id) values ('?','?','?','?','?','?');";
                        $query  = $db->makeQuery($query, $request->liid, $request->liCorrelation, $request->targetType, $request->targetNumber, $request->df2id, $request->df3id );
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query); 
                        
                        if(MODIFY_CALLER_REGEXP == 1)     
                        {                                          
                                $liobj->search_caller = preg_replace(CALLER_REGEXP_PATTERN, CALLER_REGEXP_REPLACE, $liobj->search_caller);
                                if(ADD_REPLACE_FLAGS == 1)
                                {       
                                        $liobj->search_caller = "/".$liobj->search_caller."/".REPLACE_FLAGS;
                                }         
                        }
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          	        		        	
                        /* insert into our table */
                        $query = "INSERT INTO voip_intercept (gid, aid, LIID, uuid, number, sip_username, sip_domain, search_callee, search_caller, search_ip, "
                                 ."cc_required, delivery_host, delivery_port, delivery_pass, cc_delivery_host,cc_delivery_port, modify_timestamp, create_timestamp,"
                                 ."start_time, stop_time, description, deleted) values ('?','?','?','?','?','?','?','?','?','?',"
                                 ."'?','?','?','?','?','?',NOW(), NOW(),"
                                 ."FROM_UNIXTIME(".$liobj->start_time."),FROM_UNIXTIME(".$liobj->stop_time."),'?','?');";
                        $query  = $db->makeQuery($query, $liobj->gid, $liobj->aid, $liobj->LIID = $request->liid, $liobj->uuid, $liobj->number, $liobj->sip_username,
				$liobj->sip_domain, $liobj->search_callee, $liobj->search_caller, $liobj->search_ip, $liobj->cc_required, $liobj->delivery_host, $liobj->delivery_port,
				$liobj->delivery_user, $liobj->delivery_pass, $liobj->cc_delivery_host, $liobj->cc_delivery_post, $liobj->modify_timestamp, $liobj->create_timestamp,
				$liobj->description, 0
			);
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query);                        

                        #CREATE                        
                        $this->sendRestCommand("CREATE", $liobj);
        
                        $response = array('success' => $success);                 
        		return $response; 
                }
                else {
                
                        $response = array(
                                'errorcode' => 101,
                                'errormessage' => "Target is already active" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>101</errorcode><errormessage>Target is already active</errormessage></fault>';
                	$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","Target '".$request->liid."' is already active", null, $var);         		 
                }        									
        
                return;				
	}
  
	public function ModifyInterception($request)
	{
		//$body = stdclass"  
		/* stdClass Object
		    (
		        [liid] =&gt; 12345
		        [liCorrelation] =&gt; 54321
		        [targetType] =&gt; EMAIL
		        [targetNumber] =&gt; sorry@hamma.net
		        [df2id] =&gt; 222
		        [df3id] =&gt; 333
		    )
		*/
    
		/* get our DB */
                $db = $this->getContainer('db');
                $success = false;

		$query = "SELECT COUNT(*) as cnt FROM li_records WHERE liid=".$request->liid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$cnt = $row['cnt'];
		$cnt+=0;
		
		if($cnt == 1 )
                {

                        
                        $liobj = new stdclass();                        
                        $liobj->uuid = $this->gen_uuid();
                        $liobj->id = 0;
                        
                        $query = "SELECT id, uuid FROM voip_intercept WHERE LIID = '?' LIMIT 1";
        	        $query  = $db->makeQuery($query, $request->liid);        	                                
        	        $uuids = $db->loadObjectArray($query);
        	        foreach($uuids as $uuid) {        	                
        	                $liobj->uuid = $uuid['uuid'];
        	                $liobj->id = $uuid['id'];
	        	}                                                 

                        $liobj->gid = 10;
                        $liobj->reseller_id = 0;
                        $liobj->aid = $request->liid;
                        $liobj->LIID = $request->liid;
                        $liobj->number = $request->liCorrelation;
                        $liobj->sip_username = $request->targetNumber;
                        $liobj->sip_domain = "";
                        $liobj->search_callee = "";
                        $liobj->search_caller = $request->targetNumber;
                        $liobj->search_ip = "";
                        $liobj->cc_required = 0;
                        $liobj->delivery_host = "";
                        $liobj->delivery_port = "";
                        $liobj->delivery_user = "";
                        $liobj->delivery_pass = "";
                        $liobj->cc_delivery_host = "";
                        $liobj->cc_delivery_post = "";
                        $liobj->modify_timestamp = "";
                        $liobj->create_timestamp = "";
                        $liobj->start_time = time() - 100;
                        /* STOP TIME */
                        $liobj->stop_time = time() + (365 * 86400);
                        $liobj->description = "Desciption";
                                                 

                        if($request->df2id > 0)
                        {                                                
                                               
                	        $query = "SELECT * FROM df_location WHERE dfid = '?' LIMIT 1";
                	        $query  = $db->makeQuery($query, $request->df2id);        	                                
        	                $dflocs = $db->loadObjectArray($query);
        	                if(count($dflocs) > 0) 
        	                {
                	                foreach($dflocs as $df) {
                                                $liobj->cc_required = 1;
                        	                $liobj->delivery_host = $df['ip'];
                	                        $liobj->delivery_port = $df['port'];
                        	                $liobj->delivery_user = $df['user'];
                	                        $liobj->delivery_pass = $df['password'];        	                                                                                        	        	        	        	
                	        	} 
                                }
                                else {                
                                        $response = array(
                                                'errorcode' => 108,
                                                'errormessage' => "DF does not exist and cannot be used for delivery" 
                        		); 

                                        $body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>108</errorcode><errormessage>DF does not exist and cannot be used for delivery</errormessage></fault>';
                			$var = new SoapVar ($body_xml, XSD_ANYXML);

        	                	throw new SoapFault("Server","DF '".$request->df2id."' does not exist and cannot be used for delivery", null, $var);         		 
                                }        									
                        }                                
	        	
	        	if($request->df3id > 0)
	        	{
        	        	$query = "SELECT * FROM df_location WHERE dfid = '?' LIMIT 1";
                	        $query  = $db->makeQuery($query, $request->df3id);        	                                
        	                $dflocs = $db->loadObjectArray($query);
        	                if(count($dflocs) > 0) 
        	                {
                	                foreach($dflocs as $df) {
                                                $liobj->cc_required = 1;
                        	                $liobj->cc_delivery_host = $df['ip'];
        	                                $liobj->cc_delivery_post = $df['port'];
                                        } 
                                }
                                else {
                
                                        $response = array(
                                                'errorcode' => 108,
                                                'errormessage' => "DF does not exist and cannot be used for delivery" 
                        		); 
                        		
                        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>108</errorcode><errormessage>DF does not exist and cannot be used for delivery</errormessage></fault>';
                			$var = new SoapVar ($body_xml, XSD_ANYXML);

        	                	throw new SoapFault("Server","DF '".$request->df3id."' does not exist and cannot be used for delivery", null, $var);         		 
                                }        									
                        }                        
                                       
                        #First delete                                        
                        $query = "delete FROM li_records WHERE liid=".$request->liid;
                        $db->executeQuery($query);                        
                        
                        #Now Insert again
                        $query = "INSERT INTO li_records (liid, liCorrelation, targetType, targetNumber, df2id, df3id) values ('?','?','?','?','?','?');";
                        $query  = $db->makeQuery($query, $request->liid, $request->liCorrelation, $request->targetType, $request->targetNumber, $request->df2id, $request->df3id );
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query);                        
                        $success = true;                                                                                        
	        	
	        	$query = "delete FROM voip_intercept WHERE LIID=".$request->liid;
                        $db->executeQuery($query);
                        
                        if(MODIFY_CALLER_REGEXP == 1)    
                        {                                               
                                $liobj->search_caller = preg_replace(CALLER_REGEXP_PATTERN, CALLER_REGEXP_REPLACE, $liobj->search_caller);
                                if(ADD_REPLACE_FLAGS == 1)                          
                                {
                                        $liobj->search_caller = "/".$liobj->search_caller."/".REPLACE_FLAGS;
                                }         
                        }
                                                                                                                                 	        	
                        /* insert into our table */
                        $query = "INSERT INTO voip_intercept (id, aid, gid, LIID, uuid, number, sip_username, sip_domain, search_callee, search_caller, search_ip, "
                                 ."cc_required, delivery_host, delivery_port, delivery_pass, cc_delivery_host,cc_delivery_port, modify_timestamp, create_timestamp,"
                                 ."start_time, stop_time, description, deleted) values ('?','?','?','?','?','?','?','?','?','?','?',"
                                 ."'?','?','?','?','?','?',NOW(), NOW(),"
                                 ."FROM_UNIXTIME(".$liobj->start_time."),FROM_UNIXTIME(".$liobj->stop_time."),'?','?');";
                        $query  = $db->makeQuery($query, $liobj->id, $liobj->aid, $liobj->gid, $liobj->LIID = $request->liid, $liobj->uuid, $liobj->number, $liobj->sip_username,
				$liobj->sip_domain, $liobj->search_callee, $liobj->search_caller, $liobj->search_ip, $liobj->cc_required, $liobj->delivery_host, $liobj->delivery_port,
				$liobj->delivery_user, $liobj->delivery_pass, $liobj->cc_delivery_host, $liobj->cc_delivery_post, $liobj->modify_timestamp, $liobj->create_timestamp,
				$liobj->description, 0
			);
                        //syslog(LOG_WARNING, "QI: ".$query); 
                        $db->executeQuery($query);               
                        
                        #UPDATE        
                        $this->sendRestCommand("UPDATE", $liobj);         
                        
                        $response = array('success' => $success);                         
	        	return $response; 
                        
                }
                else {
                
                        $response = array(
                                'errorcode' => 100,
                                'errormessage' => "Target is not active and cannot be modified" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>100</errorcode><errormessage>Target is not active and cannot be modified</errormessage></fault>';
                	$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","Target '".$request->liid."' is not active and cannot be modified", null, $var);         		 
                }        						
	}
	
	/* interceptions */
	public function DeleteInterception($liid)
	{
	        /* get our DB */
                $db = $this->getContainer('db');
	
	        $query = "SELECT COUNT(*) as cnt FROM li_records WHERE liid=".$liid;				
		$rows = $db->loadObjectArray($query);
		$row = $rows[0];		
		$cnt = $row['cnt'];
		$cnt+=0;
		$success = false;
		
		if($cnt == 1 )
                {
                        $query = "delete FROM li_records WHERE liid=".$liid;
                        $db->executeQuery($query);
                        $success = true;
                                                
                        $liobj = new stdclass();                        
                        $liobj->id = $liid;
                                                
                        $query = "SELECT id, uuid FROM voip_intercept WHERE LIID = '?' LIMIT 1";
        	        $query  = $db->makeQuery($query, $liid);        	                                
        	        $uuids = $db->loadObjectArray($query);
        	        foreach($uuids as $uuid) {        	                
        	                $liobj->uuid = $uuid['uuid'];
        	                $liobj->id = $uuid['id'];
	        	}                                                 

                        $query = "delete FROM voip_intercept WHERE LIID=".$liid;
                        $db->executeQuery($query);
                        $success = true;
        
                        #DELETE        
                        $this->sendRestCommand("DELETE", $liobj);             
        
                        $response = array('success' => $success);     
        		return $response;                                                                                
                }
                else {
                
                        $response = array(
                                'errorcode' => 100,
                                'errormessage' => "Target is not active and cannot be deleted" 
        		); 
        		
        		$body_xml = '<fault xsi:type="ns2:errorResponseType"><errorcode>100</errorcode><errormessage>Target is not active and cannot be deleted</errormessage></fault>';
                	$var = new SoapVar ($body_xml, XSD_ANYXML);

        		throw new SoapFault("Server","Target '".$request->liid."' is not active and cannot be deleted", null, $var);         		 
                }        									
	}
	
	public function errorResponseType($error) {
	
	        return array();	
	}

	  
	public function ConnectionCheck()
	{

		return true;
	}
  
	public function getContainer($name)
	{
        	if (!$this->_instance || !isset($this->_instance[$name]) || $this->_instance[$name] === null) {
			if($name == "db") $containerClass = sprintf("DatabaseConnect");
			$this->_instance[$name] = new $containerClass();
		}
        	return $this->_instance[$name];
	}    
	
	
	public function gen_uuid() {
 	   return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
	        // 32 bits for "time_low"
        	mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),
	        // 16 bits for "time_mid"
        	mt_rand( 0, 0xffff ),
	        // 16 bits for "time_hi_and_version",
	        // four most significant bits holds version number 4
	        mt_rand( 0, 0x0fff ) | 0x4000,	
	        // 16 bits, 8 bits for "clk_seq_hi_res",
	        // 8 bits for "clk_seq_low",
	        // two most significant bits holds zero and one for variant DCE1.1
	        mt_rand( 0, 0x3fff ) | 0x8000,
	        // 48 bits for "node"
	        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
	    );
	}
	
	public function sendRestCommand($command, $obj) {
	
		$data_string = json_encode($obj);                                                                                   
		#curl http://10.255.2.11:18090/api/interception/2bbb660b-5b9f-480c-b42e-52ca158e6741		
		$query = "SELECT * FROM agent_location WHERE active = ?";
		/* get our DB */
		$db = $this->getContainer('db');		                 
		$query  = $db->makeQuery($query, 1);        	                                
        	$dflocs = $db->loadObjectArray($query);
        	if(count($dflocs) > 0) 
        	{
                        foreach($dflocs as $df) {
                                
                                $host = $df['host'];
                	        $port = $df['port'];
                        	$proto = $df['protocol'];                        	
                        	$myurl = $proto."://".$host.":".$port."/api/interception";

                		if($command == "CREATE") {
		        	        $url = $myurl;
                			$method = "POST";
                                }
                                else if($command == "UPDATE") {
                                        $url = $myurl . "/" . $obj->uuid;
                                        $method = "PUT";
                                }
                                else if($command == "DELETE") {
                                        $url = $myurl . "/" . $obj->uuid;
                                        $method = "DELETE";			
                                }			
                                else return;
		
                                $headers = array('"X-Request-UUID: '.$obj->uuid);
                                                                                                                     
                                $ch = curl_init($url);                                                                      
                                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);                                                                     
                                curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
                                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);                                                                  
                                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
                                curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                                        'Content-Type: application/json',                                                                                
                                        'Content-Length: ' . strlen($data_string))                                                                       
                                );                                                                                                                                                                                                                                        
                                
                                $result = curl_exec($ch);
                        }
                }
                
                if(defined('CHECK_SESSION_TABLE') && CHECK_SESSION_TABLE == 1)
                {
                
                        $query = "SELECT * FROM agent_location_session WHERE active = ? AND expire_date > NOW()";
                        /* get our DB */
	        	$query  = $db->makeQuery($query, 1);        	                                
	        	$dflocs = $db->loadObjectArray($query);
                	if(count($dflocs) > 0) 
                	{
                                foreach($dflocs as $df) {        
                                        $host = $df['host'];
                        	        $port = $df['port'];
                                	$proto = $df['protocol'];                        	
                                	$myurl = $proto."://".$host.":".$port."/api/interception";

                        		if($command == "CREATE") {
		                	        $url = $myurl;
                	        		$method = "POST";
                                        }
                                        else if($command == "UPDATE") {
                                                $url = $myurl . "/" . $obj->uuid;
                                                $method = "PUT";
                                        }
                                        else if($command == "DELETE") {
                                                $url = $myurl . "/" . $obj->uuid;
                                                $method = "DELETE";			
                                        }			
                                        else return;
		
                                        $headers = array('"X-Request-UUID: '.$obj->uuid);
                                                                                                                     
                                        $ch = curl_init($url);                                                                      
                                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);                                                                     
                                        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
                                        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);                                                                  
                                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
                                        curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                                                'Content-Type: application/json',                                                                                
                                                'Content-Length: ' . strlen($data_string))                                                                       
                                        );                                                                                                                                                                                                                                        
                                
                                        $result = curl_exec($ch);
                                }
                        }
                }

	        return;
	}		
}


?>
