<?php

namespace RestApi;

class Interception {
    

    protected $_instance = array();
            
    function __construct()
    {
            if(SYSLOG_ENABLE == 1) openlog("x1-lima", LOG_PID | LOG_PERROR, LOG_LOCAL0);
    }                                  


    /**
    * Checks if a user is logged in.
    *
    * @return boolean
    */

    public function createInterception($raw){
        
        $answer = array();        
        	
        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();        
        $success = false;

        $id = $raw['id'];

	$query = "SELECT COUNT(*) as cnt FROM voip_intercept WHERE aid='".$id."'";				
	$rows = $db->loadObjectArray($query);
	$row = $rows[0];		
	$cnt = $row['cnt'];
	$cnt+=0;
	
	if($cnt == 0 )
	{
         
	    $liobj = array();
            $liobj['gid'] = 10;
            $liobj['aid'] = $raw['id'];
            $liobj['reseller_id'] = 0;
            $liobj['LIID'] = $raw['ini_id'];
            $liobj['uuid'] = $this->gen_uuid();
            $liobj['number'] = $raw['target_value'];
            $liobj['sip_username'] = "";
            $liobj['sip_domain'] = $raw['target_type'];
            $liobj['search_callee'] = $raw['target_value'];
            $liobj['search_caller'] = $raw['target_value'];
            $liobj['search_ip'] = "";
            $liobj['cc_required'] = 0;
            $liobj['delivery_host'] = $raw['x2_host'];
            $liobj['delivery_port'] = $raw['x2_port'];
            $liobj['delivery_user'] = "";
            $liobj['delivery_pass'] = "";
            $liobj['cc_delivery_host'] = $raw['x3_host'];
            $liobj['cc_delivery_port'] = $raw['x3_port'];
            $liobj['modify_timestamp'] = "";
            $liobj['create_timestamp'] = "";
            $liobj['start_time'] = time() - 100;
            /* STOP TIME */
            $liobj['stop_time'] = time() + (365 * 86400);
            $liobj['description'] = "Desciption";

            if(MODIFY_CALLER_REGEXP == 1)
            {
                    $liobj['search_caller'] = preg_replace(CALLER_REGEXP_PATTERN, CALLER_REGEXP_REPLACE, $liobj['search_caller']);
                    if(ADD_REPLACE_FLAGS == 1)                          
                    {
                        $liobj->search_caller = "/".$liobj->search_caller."/".REPLACE_FLAGS;
                    }      
            }                                                                                                 


            /* insert into our table */
            $query = "INSERT INTO voip_intercept (id, aid, gid, LIID, uuid, number, sip_username, sip_domain, search_callee, search_caller, search_ip, "
                                 ."cc_required, delivery_host, delivery_port, delivery_user, delivery_pass, cc_delivery_host,cc_delivery_port, modify_timestamp, create_timestamp,"
                                 ."start_time, stop_time, description, deleted) values (NULL,'?','10','?','?','?','?','?','?','?','?',"
                                 ."'?','?','?','?','?','?','?',NOW(), NOW(),"
                                 ."FROM_UNIXTIME(".$liobj['start_time']."),FROM_UNIXTIME(".$liobj['stop_time']."),'?','?');";
            $query  = $db->makeQuery($query, $liobj['aid'], $liobj['LIID'], $liobj['uuid'], $liobj['number'], $liobj['sip_username'],
				$liobj['sip_domain'], $liobj['search_callee'], $liobj['search_caller'], $liobj['search_ip'], $liobj['cc_required'], $liobj['delivery_host'], $liobj['delivery_port'],
				$liobj['delivery_user'], $liobj['delivery_pass'], $liobj['cc_delivery_host'], $liobj['cc_delivery_port'], $liobj['description'], 0
            );
            syslog(LOG_WARNING, "QI: ".$query); 
            $db->executeQuery($query);                        

            #CREATE                        
            $this->sendRestCommand("CREATE", $liobj);
            
            #Return
            $answer['sid'] = session_id();
            $answer['message'] = "traget has been created";             
            $answer['status'] = 201;        
            $answer['data'] = $this->getInterceptionData($liobj['aid']);            
            return $answer;
            
            //return $this->getInterception($liobj['id']);            
            //$response = array('success' => $success);                 
            //return $response; 
         }
         else {
               $response = array(
                    'status' => 409,
                    'message' => "Target is already active" 
               ); 
               
               return $response;                              
         }        		        
    }
    
    public function getInterception($id){

        $answer = array();        
        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();        
        $found = false;
        
        $query = "SELECT * FROM voip_intercept WHERE aid='".$id."'";        
        $rows = $db->loadObjectArray($query);        

        foreach($rows as $key=>$row) {
             
             $answer['id'] = $row['aid'];
             $answer['ini_id'] = (int) $row['LIID'];
             $answer['target_type'] = $row['sip_domain'];
             if (empty($answer['target_type'])) {
                 $answer['target_type'] = 'MSISDN';
             }
             $answer['target_value'] = $row['number'];
             $answer['x2_host'] = $row['delivery_host'];
             $answer['x2_port'] = (int) $row['delivery_port'];
             $answer['x3_host'] = $row['cc_delivery_host'];
             $answer['x3_port'] = (int) $row['cc_delivery_port'];
             $found = true;
        }
                
        if(!$found) {
            $success = "not found";
            $response = array('message' => $success,'status' => 404);
            return $response;
        }
        
        return $answer;
    }
    
    public function getInterceptionData($id){

        $answer = array();        
        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();        
        
        $query = "SELECT * FROM voip_intercept WHERE aid='".$id."'";        
        $rows = $db->loadObjectArray($query);        

        foreach($rows as $key=>$row) {
             
             $answer['id'] = $row['aid'];
             $answer['ini_id'] = (int) $row['LIID'];
             $answer['target_type'] = $row['sip_domain'];
             if (empty($answer['target_type'])) {
                 $answer['target_type'] = 'MSISDN';
             }
             $answer['target_value'] = $row['number'];
             $answer['x2_host'] = $row['delivery_host'];
             $answer['x2_port'] = (int) $row['delivery_port'];
             $answer['x3_host'] = $row['cc_delivery_host'];
             $answer['x3_port'] = (int) $row['cc_delivery_port'];
        }

        return $answer;
    }
    
    public function getInterceptions(){
        
        $answers = array();        
        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();        
        $query = "SELECT * FROM voip_intercept";        
        $rows = $db->loadObjectArray($query);
                
        foreach($rows as $key=>$row) {

             $answer = array();
             $answer['id'] = $row['aid'];
             $answer['ini_id'] = (int) $row['LIID'];
             $answer['target_type'] = $row['sip_domain'];
             if (empty($answer['target_type'])) {
                 $answer['target_type'] = 'MSISDN';
             }
             $answer['target_value'] = $row['number'];
             $answer['x2_host'] = $row['delivery_host'];
             $answer['x2_port'] = (int) $row['delivery_port'];
             $answer['x3_host'] = $row['cc_delivery_host'];
             $answer['x3_port'] = (int) $row['cc_delivery_port'];
             
             $answers[] = $answer;             
        }

        return $answers;
    }
    
    public function modifyInteception($id, $raw){


        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();        
        $success = false;

        $id = $raw['id'];

	$query = "SELECT COUNT(*) as cnt FROM voip_intercept WHERE aid='".$id."'";				
	$rows = $db->loadObjectArray($query);
	$row = $rows[0];		
	$cnt = $row['cnt'];
	$cnt+=0;
	
	if($cnt == 1 )
	{
         
	    $liobj = array();
            $liobj['gid'] = 10;
            $liobj['aid'] = $raw['id'];
            $liobj['LIID'] = $raw['ini_id'];
            $liobj['uuid'] = $this->gen_uuid();
            $liobj['number'] = $raw['target_value'];
            $liobj['target_type'] = $raw['target_type'];
            $liobj['sip_username'] = "";
            $liobj['sip_domain'] = $raw['target_type'];
            $liobj['search_callee'] = $raw['target_value'];
            $liobj['search_caller'] = $raw['target_value'];
            $liobj['search_ip'] = "";
            $liobj['cc_required'] = 0;
            $liobj['delivery_host'] = $raw['x2_host'];
            $liobj['delivery_port'] = $raw['x2_port'];
            $liobj['delivery_user'] = "";
            $liobj['delivery_pass'] = "";
            $liobj['cc_delivery_host'] = $raw['x3_host'];
            $liobj['cc_delivery_port'] = $raw['x3_port'];
            $liobj['modify_timestamp'] = "";
            $liobj['create_timestamp'] = "";
            $liobj['start_time'] = time() - 100;
            /* STOP TIME */
            $liobj['stop_time'] = time() + (365 * 86400);
            $liobj['description'] = "Desciption";
            
            $query = "delete FROM voip_intercept WHERE aid='".$raw['id']."'";
            
            $db->executeQuery($query);            

            if(MODIFY_CALLER_REGEXP == 1)
            {
                    $liobj['search_caller'] = preg_replace(CALLER_REGEXP_PATTERN, CALLER_REGEXP_REPLACE, $liobj['search_caller']);
            }                                                                                                 

            /* insert into our table */
            $query = "INSERT INTO voip_intercept (id, aid, gid, LIID, uuid, number, sip_username, sip_domain, search_callee, search_caller, search_ip, "
                                 ."cc_required, delivery_host, delivery_port, delivery_user, delivery_pass, cc_delivery_host,cc_delivery_port, modify_timestamp, create_timestamp,"
                                 ."start_time, stop_time, description, deleted) values (NULL,'?','10','?','?','?','?','?','?','?','?',"
                                 ."'?','?','?','?','?','?','?',NOW(), NOW(),"
                                 ."FROM_UNIXTIME(".$liobj['start_time']."),FROM_UNIXTIME(".$liobj['stop_time']."),'?','?');";
            $query  = $db->makeQuery($query, $liobj['aid'], $liobj['LIID'], $liobj['uuid'], $liobj['number'], $liobj['sip_username'],
				$liobj['sip_domain'], $liobj['search_callee'], $liobj['search_caller'], $liobj['search_ip'], $liobj['cc_required'], $liobj['delivery_host'], $liobj['delivery_port'],
				$liobj['delivery_user'], $liobj['delivery_pass'], $liobj['cc_delivery_host'], $liobj['cc_delivery_port'], $liobj['description'], 0
            );

            //syslog(LOG_WARNING, "QI: ".$query); 
            $db->executeQuery($query);                        

            #CREATE                        
            $this->sendRestCommand("UPDATE", $liobj);
            
            #Return
            return $this->getInterceptionData($liobj['aid']);            
            //$response = array('success' => $success);                 
            //return $response; 
         }
         else {
               $response = array(
                    'status' => 404,
                    'errorcode' => 101,
                    'errormessage' => "Target doesn't exist" 
               ); 
               
               return $response;                              
         }        		        

        $answer['sid'] = session_id();
        $answer['auth'] = false;             
        $answer['status'] = 403;        
        $answer['message'] = 'wrong session';
        $answer['data'] = array();                
        
        return $answer;
    }
    
    public function deleteInterception($id){

        $db = $this->getContainer('db');
        $db->select_db(DB_LIMA);
        $db->dbconnect();  

        $found = false;      

        $liobj = array();            
        $liobj['id'] = $id;
                                                
        $query = "SELECT id, uuid FROM voip_intercept WHERE aid='".$id."' LIMIT 1";
        $uuids = $db->loadObjectArray($query);
        foreach($uuids as $key=>$uuid) {
        	$liobj['uuid'] = $uuid['uuid'];
                $liobj['id'] = $uuid['id'];
                $found = true;
        }  
        
        
        if($found) {        
            $query = "DELETE FROM voip_intercept WHERE aid='".$id."'";        
            $rows = $db->loadObjectArray($query);        

            #DELETE        
            $this->sendRestCommand("DELETE", $liobj);
            $success = "success";
            $response = array('message' => $success, 'status' => 204);
            return $response;           
            
        } else {
            $success = "not found";
            $response = array('message' => $success,'status' => 404);
            return $response;                   
        }
    }
    
    public function getPing(){
        
        $success = "success";        
        $response = array('success' => $success);
        return $response;            
    }

    public function getContainer($name)
    {
	if (!$this->_instance || !isset($this->_instance[$name]) || $this->_instance[$name] === null) {
            //$config = \Config::factory('configs/config.ini', APPLICATION_ENV, 'auth');
             if($name == "db") $containerClass = sprintf("Database\\".DATABASE_CONNECTOR);
             else if($name == "layer") $containerClass = sprintf("Database\\Layer\\".DATABASE_DRIVER);
             
            $this->_instance[$name] = new $containerClass();
        }

        return $this->_instance[$name];
    }
    
    public function gen_uuid() {
 	   return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
	        // 32 bits for "time_low"
        	mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),
	        // 16 bits for "time_mid"
        	mt_rand( 0, 0xffff ),
	        // 16 bits for "time_hi_and_version",
	        // four most significant bits holds version number 4
	        mt_rand( 0, 0x0fff ) | 0x4000,	
	        // 16 bits, 8 bits for "clk_seq_hi_res",
	        // 8 bits for "clk_seq_low",
	        // two most significant bits holds zero and one for variant DCE1.1
	        mt_rand( 0, 0x3fff ) | 0x8000,
	        // 48 bits for "node"
	        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
	    );
     }

     public function sendRestCommand($command, $obj) {
	
		$data_string = json_encode($obj);                                                                                   
		#curl http://10.255.2.11:18090/api/interception/2bbb660b-5b9f-480c-b42e-52ca158e6741		
		$query = "SELECT * FROM agent_location WHERE active = ?";
		
	        /* get our DB */
		$db = $this->getContainer('db');		                 
		$query  = $db->makeQuery($query, 1);        	                                
        	$dflocs = $db->loadObjectArray($query);
        	if(count($dflocs) > 0) 
        	{
                        foreach($dflocs as $df) {
                                
                                $host = $df['host'];
                	        $port = $df['port'];
                        	$proto = $df['protocol'];                        	
                        	$myurl = $proto."://".$host.":".$port."/api/interception";

                		if($command == "CREATE") {
		        	        $url = $myurl;
                			$method = "POST";
                                }
                                else if($command == "UPDATE") {
                                        $url = $myurl . "/" . $obj['uuid'];
                                        $method = "PUT";
                                }
                                else if($command == "DELETE") {
                                        $url = $myurl . "/" . $obj['uuid'];
                                        $method = "DELETE";			
                                }			
                                else return;
		
                                $headers = array('"X-Request-UUID: '.$obj['uuid']);
                                                                                                                     
                                $ch = curl_init($url);                                                                      
                                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);                                                                     
                                curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
                                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);                                                                  
                                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
                                curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                                        'Content-Type: application/json',                                                                                
                                        'Content-Length: ' . strlen($data_string))                                                                       
                                );                                                                                                                                                                                                                                        
                                
                                $result = curl_exec($ch);
                        }
                }
                
                if(defined('CHECK_SESSION_TABLE') && CHECK_SESSION_TABLE == 1)
                {
                
                        $query = "SELECT * FROM agent_location_session WHERE active = ? AND expire_date > NOW()";
                        /* get our DB */
	        	$query  = $db->makeQuery($query, 1);        	                                
	        	$dflocs = $db->loadObjectArray($query);
                	if(count($dflocs) > 0) 
                	{
                                foreach($dflocs as $df) {        
                                        $host = $df['host'];
                        	        $port = $df['port'];
                                	$proto = $df['protocol'];                        	
                                	$myurl = $proto."://".$host.":".$port."/api/interception";

                        		if($command == "CREATE") {
		                	        $url = $myurl;
                	        		$method = "POST";
                                        }
                                        else if($command == "UPDATE") {
                                                $url = $myurl . "/" . $obj['uuid'];
                                                $method = "PUT";
                                        }
                                        else if($command == "DELETE") {
                                                $url = $myurl . "/" . $obj['uuid'];
                                                $method = "DELETE";			
                                        }			
                                        else return;
		
                                        $headers = array('"X-Request-UUID: '.$obj['uuid']);
                                                                                                                     
                                        $ch = curl_init($url);                                                                      
                                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);                                                                     
                                        curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);                                                                  
                                        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);                                                                  
                                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
                                        curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
                                                'Content-Type: application/json',                                                                                
                                                'Content-Length: ' . strlen($data_string))                                                                       
                                        );                                                                                                                                                                                                                                        
                                
                                        $result = curl_exec($ch);
                                }
                        }
                }

	        return;
     }	
     	
}

?>